from dsim.node import Node
from typing import TypeVar, List

T = TypeVar('T')

ListLarray = List[T]


class Larray:
    def __init__(self, head_Node: Node[T] | None = None) -> None:
        self._head: Node[T] | None = head_Node

    @property
    def head(self) -> Node[T]:
        return self._head

    @head.setter
    def head(self, new_head_Node: Node[T]) -> None:
        self._head = new_head_Node

    def __str__(self) -> str:
        if self._head is None:
            return "Empty Larray"

        curNode = self._head
        string = f"[{self._head}, "
        while True:
            if curNode.next is None:
                string += f"{curNode}]"
                return string

            curNode = curNode.next
            string += f"{curNode}, "

    def __len__(self) -> int:

        if self._head is None:
            return 0

        count = 0

        curNode = self._head
        while True:
            if curNode.next is None:
                return count

            curNode = curNode.next
            count += 1

    def __list__(self) -> ListLarray:

        if self._head is None:
            return []

        lst = []
        curNode = self._head

        while True:
            lst.append(curNode.value)

            if curNode.next is None:
                return lst

            curNode = curNode.next
